#!/usr/bin/perl

$gBaseURL = ".";
$gBaseDIR = ".";
$gIconURL = "./images";
$gCGI_URL = "./wj_memo.cgi";

$gMakeBoard = "Y";
$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;
sub parseArgument {
	local($buffer,$data,$name,$value);
	local(@datum);

	if($ENV{'REQUEST_METHOD'} eq "GET") {
		$buffer = $ENV{'QUERY_STRING'};
	}
	else {
		read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
	}

	@datum = split(/&/,$buffer);
	foreach $data (@datum) {
		($name,$value) = split(/=/,$data);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

		$FORM{$name} = $value;
	}
	if($FORM{'id'}) {
		$gBaseDIR = "$gBaseDIR/$FORM{'id'}";
		$gNumFile = "$FORM{'id'}.num";
		$gCfgFile = "$FORM{'id'}.cfg";
		$gPwdFile = "$FORM{'id'}.pwd";
		$gDatFile = "$FORM{'id'}.idx";
	}
	else {
		&HTMLHeader;

		print "<form name=id>\n";
		print "<table border cellpadding=3 cellspacing=0 width=300 bgcolor=#f3f3f3 bordercolordark=#ffffff bordercolorlight=#c0c0c0>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center><font style=\"font-size:9pt\"> memo cgi </font></td></tr>\n";
		print "<tr><td height=40 align=center><font style=\"font-size:9pt\">  DB  </font><input type=text name=id size=15 value=$DBname></td></tr>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center>\n";
		print "<input type=submit value=\" DB  \" style=\"height:18px;font-size:9pt;background-color:#f3f3f3;border:1 solid #787878;cursor: hand\" OnClick=\"url_go('$gCGI_URL?id=$DBname')\">\n";
		print "</table></td></tr></table>\n";
		print "</form>\n";

		&HTMLFooter;
	}
	if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
		close(HANDLE);
		&selectAction;
	}
	else {
		if($gMakeBoard eq "Y") {
			&selectAction;
		}
		else {
			&HTMLHeader;
				print "<font style=\"font-size:9pt\">ڿ   Ǿ ֽϴ!</font>\n";
			&HTMLFooter;
		}
	}
}

sub selectAction {
	&getNumber;
	&getEnvVar;

	unless($FORM{'action'}) {
		$FORM{'action'} = "read";
	}
	if($FORM{'action'} eq "read") {	
		&readData;
	} 
	elsif($FORM{'action'} eq "write") {
		&writeData;
	} 
	elsif($FORM{'action'} eq "users_login") {
		&showUsersLogin;
	}
	elsif($FORM{'action'} eq "delete") {
		&checkUserPassword;
		&deleteData;
	} 
	elsif($FORM{'action'} eq "admin_login") {
		&showAdminLogin;
	}
	elsif($FORM{'action'} eq "config_form") {
		&checkAdminPassword;
		&showConfigForm;
	}
	elsif($FORM{'action'} eq "config") {
		&updateEnvVar;
	}
	else {
		exit;
	}
}

sub getNumber {
	if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
		$gNoOfData = <HANDLE>;
		close(HANDLE);
		chop($gNoOfData);

		open(HANDLE,"<$gBaseDIR/$gDatFile");
			@datum = <HANDLE>;
		close(HANDLE);
		if($gNoOfData != $#datum) {
			$gNoOfData = $#datum;
			&putNumber;
		}
	}
	else {
		mkdir("$gBaseDIR",0777);  
		mkdir("$gBaseDIR/messages",0777);

		open(HANDLE,">$gBaseDIR/$gDatFile");
			print HANDLE "<!--EOF-->\n";
		close(HANDLE);

		$gNoOfData = "0";
		&putNumber;
	} 
}

sub putNumber {
	open(HANDLE,">$gBaseDIR/$gNumFile");
		print HANDLE "$gNoOfData\n";
	close(HANDLE);
}

sub getEnvVar {
	local($env_list);
	local(@datum);

	if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
		$env_list = <HANDLE>;
		close(HANDLE);
		@datum = split(/\|/,$env_list);

		$gBackColor = $datum[1];
		$gBackImage = $datum[2];
		$gTableText = $datum[3];
		$gTableWidth = $datum[4];
		$gRecPerPage = $datum[5];
		$gDateText = $datum[6];
		$gNameText = $datum[7];
		$gBaseText = $datum[8];
		$gTagUse = $datum[9];
		$gMemoLength = $datum[10];
		$gListHover = $datum[11];
		$gTextSize = $datum[12];
		$gTextFamily = $datum[13];
		$gLink = $datum[14];
		$gLinkVisited = $datum[15];
		$gLinkActive = $datum[16];
		$gLinkHover = $datum[17];

		chop($gHomeImageURL);
    }
	else {

		$gBackColor = "#ffffff";
		$gBackImage = "";
		$gBaseText = "#787878";
		$gTableText = "#787878";
		$gTableWidth = "550"; 
		$gRecPerPage = "21";
		$gDateText = "#787878";
		$gNameText = "#787878";
		$gTagUse = "NO";
		$gMemoLength = "30";
		$gListHover = "#f3f3f3";
		$gTextSize = "9pt";
		$gTextFamily = "";
		$gLink = "#787878";
		$gLinkVisited = "#787878";
		$gLinkActive = "#222222";
		$gLinkHover = "#c0c0c0";

		&putEnvVar;
	}
}
 
sub putEnvVar {
	open(HANDLE,">$gBaseDIR/$gCfgFile");
		print HANDLE "^^|$gBackColor|$gBackImage|$gTableText|$gTableWidth|$gRecPerPage|$gDateText|$gNameText|$gBaseText|$gTagUse|$gMemoLength|$gListHover|$gTextSize|$gTextFamily|$gLink|$gLinkVisited|$gLinkActive|$gLinkHover|\n";
	close(HANDLE);
}

sub readData {
	if($FORM{'p'}) {
		$gCurPage = $FORM{'p'};
	}
	else {
		$gCurPage = "1";
	}

	$gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

	&HTMLHeader;
	&showInputForm;
	&readIndexFile;
	&HTMLFooter;
}

sub readIndexFile {
	local($i,$j,$actual_number,$short_subject,$short_date,$old_date,$new_date);
	local(@datum,@value);

	open(HANDLE,"$gBaseDIR/$gDatFile");
		@datum = <HANDLE>;
	close(HANDLE);

	for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
		@value = split(/\|/,$datum[$i]);    
		$actual_number = ($gNoOfData+1)-$i;

		if($actual_number > 0) {
			$short_subject = $value[2];
			$short_date= $value[5];

			if($i%2) {
				print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0>\n";
				print "<tr onMouseOver=this.style.backgroundColor='$gListHover' onMouseOut=this.style.backgroundColor=''>\n";
			}
			else {
				print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0>\n";
				print "<tr onMouseOver=this.style.backgroundColor='$gListHover' onMouseOut=this.style.backgroundColor=''>\n";
			}
			print "<td><table width=100% border=0 cellspacing=0 cellpadding=3>\n";
			print "<tr><td align=left>&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIconURL/delete.gif border=0 alt=ϱ></a> <font color=$gDateText>$short_date</font> <img src=$gIconURL/pen.gif> <font color=$gNameText>$value[3]</font>\n";
			print " <font style=\"font-size:9pt;font-family:verdana\"><b>:::</b></font> <font color=$gTableText>$short_subject</font></a></td></tr></table></td></tr>\n";
			print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
			print "</table>\n";
		}
	}
	unless($gNoOfData) { 
		print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=6>\n";
		print "<tr align=center><td> ޸ ϴ.\n";
		print "</table>\n";
	}
	&MenuButton;
}

sub MenuButton {
	local($prev_page,$next_page);
	print "<table border=0 cellspacing=0 cellpadding=0 width=$gTableWidth>\n";
	print "<tr><td colspan=99><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
	print "<tr><td><table border=0 cellspacing=0 cellpadding=3 width=100%><tr><td>";
	if ($gCurPage == 1) {
		print "&nbsp; <font style=\"font-size:9pt;font-family:verdana\"><b>:::</b></font>\n";
	}
	else {
		$prev_page = $gCurPage-1;
		print "&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$prev_page></a> <font style=\"font-size:9pt;font-family:verdana\"><b>:::</b></font>\n"
	}
	if($gCurPage eq $gTotPage) {
		print "</font>\n";
	}
	else {
		$next_page = $gCurPage+1;
		print "<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$next_page></a>\n"
	}
	### Ʒ  ΰ   ###
    print "</td><td align=center><a href=http://soback.kornet21.net/~zeusso title=\" ϴ Ȩ \" target=_blank><font style=\"font-size:8pt;font-face:Verdana\">wonie</font></a><font style=\"color:$gNameText;font-size:7pt\"> ::: </font><a href=http://www.khim.pe.kr/ title=\"  Ȩ \" target=_blank><font style=\"font-size:8pt;font-face:Verdana\">Khim</font></a></td>\n";
	print "<td align=right><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>ΰħ</a> <font style=\"font-size:9pt;font-family:verdana\"><b>:::</b></font> <a href=$gCGI_URL?id=$FORM{'id'}&action=admin_login&p=$gCurPage&c=config_form>ȯ漳</a>&nbsp;</td></tr></table>\n";
	print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
	print "</td></tr></table>\n";
}

sub HTMLHeader {
	print "Content-type: text/html\n\n";
	print "<!-------------------------------------------------------->\n";
	print "<!--                                                    -->\n";
	print "<!--    ƾ: ̼                                -->\n";
	print "<!--    ¥: 98/09/14                              -->\n";
	print "<!--    ڿ: zeusso\@nownuri.net                    -->\n";
	print "<!--    Ȩ: http://soback.kornet21.net/~zeusso    -->\n";
	print "<!--                                                    -->\n";
	print "<!--    ƾ:                                 -->\n";
	print "<!--    ¥: 2001/01/02                            -->\n";
	print "<!--    ڿ: thief\@khim.pe.kr                      -->\n";
	print "<!--    Ȩ: http://www.khim.pe.kr/                -->\n";
	print "<!--                                                    -->\n";
	print "<!-------------------------------------------------------->\n";
	print "<html>\n";
	print "<head>\n";
	print "    <title> memo.cgi </title>\n";
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
	print "<style>\n";
	print "<!--\n";
	print "    a:link     { color :$gLink; text-decoration:none }\n";
	print "    a:visited  { color :$gLinkVisited; text-decoration:none }\n";
	print "    a:active   { color :$gLinkActive; text-decoration:none }\n";
	print "    a:hover    { color :$gLinkHover; text-decoration:underline }\n";
	print "    body,td,   { font-size:$gTextSize;color:$gBaseText;font-family:$gTextFamily }\n";
	print "    body       { background:$gBackColor; background-attachment: fixed; background-image: url($gBackImage); background-repeat: no-repeat; background-position: center center }\n";
	print "    select,input,form,textarea,option { color:$gBaseText;font-size:$gTextSize }\n";
	print "-->\n";
	print "</style>\n" ;
	print "<script language=\"JavaScript\">\n";
	print "    function nextWin(){\n";
	print "        location = \"$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}\"\n";
	print "}\n";
	print "</script>\n";
	print "<script language=javascript>\n";
	print "    function clearField(field){\n";
	print "        if (field.value == field.defaultValue) {\n";
	print "            field.value = '';\n";
	print "        }\n";
	print "}\n";
	print "    function checkField(field){ \n";
	print "        if (field.value == '') {\n";
	print "            field.value = field.defaultValue;\n";
	print "        }\n";
	print "}\n";
	print "</script>\n";
	print "</head>\n";

	if($gDelayTime == 0) {
		print "<body topmargin=10>\n";
	}
	else {
		print "<meta http-equiv=refresh content=1;url=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>\n";
		print "<body topmargin=10>\n";
	}
	print "<center>\n";    
}

sub HTMLFooter {
	print "</center>\n";
	print "</body>\n";
	print "</html>\n";
	exit;
}

sub PageFooter {
	print"\n";
}

sub showInputForm {
	local($data,$subject,$name,$value);
	local(@value,@cookies);
    
	if($ENV{'HTTP_COOKIE'}) {
		@cookies = split(/; /,$ENV{'HTTP_COOKIE'});
		foreach(@cookies) {
			($name,$value) = split(/=/,$_);
			$COOKIE{$name} = $value;
		}
	}
	print "<table border=0 cellspacing=0 cellpadding=0 width=$gTableWidth>\n";
	print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
	print "<tr><td>\n";
	print "<table width=100% cellpadding=1 cellspacing=0 border=0>";
	print "<form method=post action=$gCGI_URL>\n";
	print "<input type=hidden name=id value=$FORM{'id'}>\n";
	print "<input type=hidden name=action value=write>\n";
	print "<input type=hidden name=p value=1>\n";
	print "<input type=hidden name=action value=write>\n";
	print "<input type=hidden name=passwd maxlength=8>\n";
	print "<tr align=center><td≯ <input name=name type=text size=8 value=\" 8ڱ \" maxlength=8 style=\"height:18px;background:;border:1 solid $gBaseText\" onblur=checkField(this) onfocus=clearField(this)>\n";
	print "ϱ <input name=subject type=text size=42 value=\" $gMemoLengthڱ   ֽϴ \" maxlength=$gMemoLength style=\"height:18px;background:;border:1 solid $gBaseText\" onblur=checkField(this) onfocus=clearField(this)>\n"; 
	print "<input type=submit value=\"\" style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">&nbsp;<input type=reset value=\"\" style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\"></td></tr>\n";
	print "</table></td></tr>\n";
	print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
	print "<input type=hidden name=html value=enable checked>\n";
	print "</table>\n";
}

sub writeData {
	&getNumber;
	&getVariable;
	print "Set-Cookie: UN=$name; expires=Sunday, 12-Dec-1999 12:12:12 GMT;\r\n";

	&makeCryptPassword if($passwd);
	&makeNewFile;
	&appendIndexFile;
	$gNoOfData++;
	&putNumber;

	$gDelayTime = 500;
	&HTMLHeader;
		print "<p>޸ ּż մϴ.\n";
		print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}></a>]\n";
	&HTMLFooter;
}

sub getVariable {
	if($FORM{'passwd'}) {
		$passwd = "$FORM{'passwd'}";
	}
	unless($FORM{'name'} =~ /^\s*$/) {
		$name = "$FORM{'name'}";
		if($FORM{'name'} eq ' 8ڱ ') {
			&error(no_name);
		}
		else {
			$subject =~ s/\|/&#124;/g;
		}
	}
	else {
		&error(no_name);
	}
	unless($FORM{'subject'} =~ /^\s*$/) {
		$subject = "$FORM{'subject'}";
		if($FORM{'subject'} eq ' 30ڱ   ֽϴ ') {
			&error(no_subject);
		}
		else {
			if ($gTagUse eq "NO") {
				$subject =~ s/</&lt;/g;
				$subject =~ s/>/&gt;/g;
				$subject =~ s/"/&quot;/g;
				$subject =~ s/\|/&#124;/g;
			}
			$subject =~ s/\|/&#124;/g;
		}
	}
	else {
		&error(no_subject);
	}
	&getDate;
}

sub getDate {     
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

	if($sec < 10) {
		$sec = "0$sec";
	}
	if($min < 10) {
		$min = "0$min";
	}
	if($hour < 10) {
		$hour = "0$hour";
	}
	$mon++;
	if($mon < 10) {
		$mon = "0$mon";
	}
	if($mday < 10) {
		$mday = "0$mday";
	}

	$date = "$mon/$mday $hour:$min:$sec";
	$d = "$mon$mday";
}  

sub downData {
	&addHitCounter($FORM{'file'});

	print "Content-Type: application/octet-stream\n";
	print "Content-Disposition: attachment; filename=$FORM{'file'}\n\n";
	open(HANDLE,"<$gBaseDIR/files/$FORM{'file'}");
		binmode(HANDLE);
		binmode(STDOUT);
		binmode(STDERR);
		print <HANDLE>;
	close(HANDLE);
	exit;
}

sub makeCryptPassword  {
	local($crypt_code);
	local(@set);

	@set = ('a'..'z','A'..'Z','0'..'9','.','/');
	$crypt_code = "$set[9]$set[3]";
	$gCryptPassword = crypt($passwd,$crypt_code);
}

sub makeNewFile { 
	local(@set);

	@set = ('0'..'9'); 
	srand(time);
	$gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
	open(HANDLE,">$gBaseDIR/messages/$gRandomFilename.txt");
		print HANDLE "$gCryptPassword|$gRandomFilename|$name|$date|$subject|\n";
	close(HANDLE);
}

sub appendIndexFile {
	local($data);
	local(@datum,@point);

	&lock;
	open(HANDLE,"$gBaseDIR/$gDatFile");
		@datum = <HANDLE>;
	close(HANDLE);
    
	if($FORM{'l'}) {    
		open(HANDLE,">$gBaseDIR/$gDatFile");
		foreach $data (@datum) {
			@point = split(/\|/,$data);
			if($point[1] eq $FORM{'l'}) {
				$thread = $point[0] + 1;
				print HANDLE "$data";
				print HANDLE "$thread|$gRandomFilename|$subject|$name|$email|$date|0|$subject2|$homepage|\n";
			}
			else {
				print HANDLE "$data";
			}
		}
		close(HANDLE);
	}
	else {
		open(HANDLE,">$gBaseDIR/$gDatFile");
		foreach $data (@datum) {
			if($data =~ /<!--EOF-->/) {
				print HANDLE "<!--EOF-->\n";
				print HANDLE "$thread|$gRandomFilename|$subject|$name|$email|$date|0|$subject2|$homepage|\n";
			}
			else {
				print HANDLE "$data";
			}
		}
		close(HANDLE);
	}
	&unlock;
}

sub error {
	local($error) = $_[0];
    
	&HTMLHeader;
	if($error eq "no_name") {
		print "<p≯ ݵ ؾ մϴ\n";
		print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
	}
	elsif($error eq "no_subject") {
		print "<p> ݵ ؾ մϴ\n";
		print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
	}
	&HTMLFooter;
}

sub showUsersLogin {
	local($command);

	if($FORM{'c'} eq "delete") {
		$command = "delete";
	}
	else {
		$command = "show_update_form";
	}
 
    &HTMLHeader;

	print "<form method=post action=$gCGI_URL>\n";
	print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
	print "<input type=hidden name=p value=$FORM{'p'}>\n";
	print "<input type=hidden name=action value=$command>\n";
	print "<input type=hidden name=l value=$FORM{'l'}>\n";
	print "<p> йȣ Էϼ<br>\n";
	print "<input type=password name=passwd size=25 maxlength=8  style=\"background:;border:1 solid $gBaseText\"><br>\n";
	print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n" if($command eq "delete");
	print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n" if($command eq "show_update_form");
	print "</form>\n";

	&HTMLFooter;       
}

sub checkUserPassword {
	local($data,$crypt_code,$save_password,$crypt_password);
	local(@passwd,@set,@datum,@value);
 
	open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
		$data = <HANDLE>;
	close(HANDLE);
	@passwd = split(/\|/,$data);

	open(HANDLE,"$gBaseDIR/$gPwdFile");
		$save_password = <HANDLE>;
	close(HANDLE);
	chop($save_password);

	@set = ('a'..'z','A'..'Z','0'..'9','.','/');
	$crypt_code = "$set[9]$set[3]";
	$crypt_password = crypt($FORM{'passwd'},$crypt_code);

	unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
		&HTMLHeader;
			print "<p> йȣ ġ ʽϴ\n";        
			print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>ư</a>]\n";
		&HTMLFooter;
	} 
}

sub deleteData {
	local($delete_filename);
	local(@datum,@value);
 
	open(HANDLE,"$gBaseDIR/$gDatFile");
		@datum = <HANDLE>;
	close(HANDLE);
	open(HANDLE,">$gBaseDIR/$gDatFile");
	foreach $data (@datum) {
		@value = split(/\|/, $data);
		if($FORM{'l'} != $value[1]) {
			print HANDLE "$data";             
		}
		else {
			$delete_filename = $value[7];
		}
	}
	close(HANDLE);

	unlink("$gBaseDIR/messages/$FORM{'l'}.txt");
	unlink("$gBaseDIR/files/$delete_filename");
	&getNumber;
	$gNoOfData--;
	&putNumber;

	$gDelayTime = 500;
	&HTMLHeader;
		print "<p>׸  Ǿϴ\n";
		print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>ư</a>]\n";
	&HTMLFooter;
}

sub showAdminLogin {
	local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
	&HTMLHeader;
	unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
		print "<form action=$gCGI_URL>\n";
		print "<input type=hidden name=id value=$FORM{'id'}>\n";    
		print "<input type=hidden name=action value=$FORM{'c'}>\n";
		print "<input type=hidden name=p value=$FORM{'p'}>\n";
		print "<input type=hidden name=ps value=new>\n";
		print " йȣ ϼ<br>\n";
		print " йȣ <input type=password name=newpasswd size=20 maxlength=8 style=\"background:;border:1 solid $gBaseText\"><br>\n";
		print "йȣ Է <input type=password name=repasswd size=20 maxlength=8 style=\"background:;border:1 solid $gBaseText\"><br><br>\n";
		print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
		print "</form>\n";
	}
	else {
		print "<form method=post action=$gCGI_URL>\n";
		print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
		print "<input type=hidden name=action value=$FORM{'c'}>\n";
		print "<input type=hidden name=p value=$FORM{'p'}>\n";
		print "<input type=hidden name=ps value=old>\n";
		print " йȣ Էϼ<br>\n";
		print "<input type=password name=oldpasswd size=25 maxlength=8 style=\"background:;border:1 solid $gBaseText\"><br>\n";
		print "<input type=submit value=ϱ style=\"height:18px; background:; border:1 solid $gBaseText; cursor:hand\">\n";
		print "</form>\n";
	}
	&HTMLFooter;
	close(HANDLE);
}
 
sub checkAdminPassword {
	local($crypt_code,$save_password,$old_password,$new_password);
	local(@set);
    
	if($FORM{'ps'} eq "new") {  
		if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
			if($FORM{'newpasswd'} ne "") {
				@set = ('a'..'z','A'..'Z','0'..'9','.','/');
				$crypt_code = "$set[9]$set[3]";
				$save_password = crypt($FORM{'newpasswd'},$crypt_code);
				open(HANDLE,">$gBaseDIR/$gPwdFile");
					print HANDLE "$save_password\n";
					close(HANDLE);
			}
			else {
				&HTMLHeader;
					print "<p> йȣ Է ʾҽϴ\n";
					print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>ư</a>]\n";
				&HTMLFooter;
			}
		}
		else {
			&HTMLHeader;
				print "<p> йȣ ġ ʽϴ\n";
				print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>ư</a>]\n";
			&HTMLFooter;
		} 
	} 

	else { 
		open(HANDLE,"<$gBaseDIR/$gPwdFile");
			$save_password = <HANDLE>;
		close(HANDLE);
		chop($save_password);

		@set = ('a'..'z','A'..'Z','0'..'9','.','/');
		$crypt_code = "$set[9]$set[3]";
		$old_password = crypt($FORM{'oldpasswd'},$crypt_code);

		if ($gAdminOnly eq "YES"){
			unless ($old_password eq $save_password) {
				&HTMLHeader;
					print "<p> йȣ ġ ʽϴ\n";
					print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>ư</a>]\n";
				&HTMLFooter;
			}
		}
		else {
			unless ($old_password eq $save_password) {
				&HTMLHeader;
					print "<p> йȣ ġ ʽϴ\n";
					print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>ư</a>]\n";
				&HTMLFooter;
			}
		}
	}
}

sub checkConfigPassword {
	local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
	local(@set);
 
	open(HANDLE,"<$gBaseDIR/$gPwdFile");
		$save_password = <HANDLE>;
	close(HANDLE);
	chop($save_password);

	@set = ('a'..'z','A'..'Z','0'..'9','.','/');
	$crypt_code = "$set[9]$set[3]";
	$old_password = crypt($FORM{'oldpasswd'},$crypt_code);

	unless($old_password eq $save_password) {
		&HTMLHeader;
			print "<p>ȯ  Ȯ   йȣ ġ ʽϴ.\n";
			print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
		&HTMLFooter;
	}
}

sub showConfigForm {
	&HTMLHeader;

	print "<table width=450 border=1 cellspacing=0 cellpadding=4 bordercolordark=white bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::  ȣ  ::: </b></td></tr></table>";
	print "<table width=450 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
	print "<form action=$gCGI_URL>\n";
	print "<input type=hidden name=id value=$FORM{'id'}>\n";
	print "<input type=hidden name=action value=config>\n";
	print "<input type=hidden name=p value=$FORM{'p'}>\n";
	print "<input type=hidden name=ps value=new>\n";
	print "<tr><td>ο йȣ</td><td align=right> <input type=password name=newpasswd size=10 maxlength=8></td></tr>\n";
	print "<tr><td>йȣ Է</td><td align=right> <input type=password name=repasswd size=10 maxlength=8></td></tr>\n";
	print "<tr><td>\n";
	if($gMakeBoard eq "Y") {
		$gMakeBoard = "";
	} 
	else {
		$gMakeBoard = "";
	}
	print "<tr><td align=right>޸ ߰:</td><td><font color=#ff0000 size=-1><b>$gMakeBoard</b></font></td></tr>\n";
	print "</table></td></tr></table>\n";
	print "<p><table width=450 border=1 cellspacing=0 cellpadding=4 bordercolordark=white bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: ⺻ ȯ  ::: </b></td></tr></table>";
	print "<table width=450 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
	print "<tr><td>޸ </td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=10></td></tr>\n";
	print "<tr><td> </td><td align=right><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
	print "<tr><td> ׸</td><td align=right><input type=text name=BackImage value=\"$gBackImage\" size=40></td></tr>\n";
	print "</table></td></tr></table>";
	print "<p><table width=450 border=1 cellspacing=0 cellpadding=4 bordercolordark=white bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: ۸ ⺻ ȯ  ::: </b></td></tr></table>";
	print "<table width=450 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
	print "<tr><td>⺻  </td><td align=right><input type=text name=BaseText value=\"$gBaseText\" size=10></td></tr>\n";
	print "<tr><td>⺻  ũ</td><td align=right><input type=text name=TextSize value=\"$gTextSize\" size=10>\n";
	print "<tr><td>⺻ ۲</td><td align=right><input type=text name=TextFamily value=\"$gTextFamily\" size=10>\n";
	print "<tr><td>ũ </td><td align=right><input type=text name=Link value=\"$gLink\" size=10></td></tr>\n";
	print "<tr><td>湮 ũ</td><td align=right><input type=text name=LinkVisited value=\"$gLinkVisited\" size=10></td></tr>\n";
	print "<tr><td>Ȱȭ ũ</td><td align=right><input type=text name=LinkActive value=\"$gLinkActive\" size=10></td></tr>\n";
	print "<tr><td>ũ hover</td><td align=right><input type=text name=LinkHover value=\"$gLinkHover\" size=10></td></tr>\n";
	print "<tr><td>  </td><td align=right><input type=text name=TableText value=\"$gTableText\" size=10>\n";
	print "<tr><td>¥ κ </td><td align=right><input type=text name=DateText value=\"$gDateText\" size=10></td></tr>\n";
	print "<tr><td≯ κ </td><td align=right><input type=text name=NameText value=\"$gNameText\" size=10></td></tr>\n";
	print "<tr><td>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=10></td></tr>\n";
	print "<tr><td>޸ </td><td align=right><input type=text name=MemoLength value=\"$gMemoLength\" size=10></td></tr>\n";
	print "<tr><td>ListHover </td><td align=right><input type=text name=ListHover value=\"$gListHover\" size=10></td></tr>\n";
	print "<tr><td>HTML </td><td align=right><select name=TagUse>";
	if($gTagUse eq "YES") {
		print "<option value=YES selected>";
		print "<option value=NO>";
	}
	else {
		print "<option value=YES>";
		print "<option value=NO selected>";
	}
	print "</select></td></tr>\n";
	print "</table></td></tr></table>";
	print "<p>\n";
	print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
	print "</form>\n";

	&HTMLFooter;
}

sub updateEnvVar {
	&checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

	$gBackColor = $FORM{'BackColor'};
	$gBaseText = $FORM{'BaseText'};
	$gBackImage = $FORM{'BackImage'} if($FORM{'BackImage'} =~ /^http:\/\// || $FORM{'BackImage'} eq "");
	$gTableText = $FORM{'TableText'};
	$gTableWidth = $FORM{'TableWidth'};         
	$gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
	$gDateText = $FORM{'DateText'};
	$gNameText = $FORM{'NameText'};
	$gMemoLength = $FORM{'MemoLength'};
	$gListHover = $FORM{'ListHover'};
	$gTagUse = $FORM{'TagUse'};
	$gTextSize = $FORM{'TextSize'};
	$gTextFamily = $FORM{'TextFamily'};
	$gLink = $FORM{'Link'};
	$gLinkVisited = $FORM{'LinkVisited'};
	$gLinkActive = $FORM{'LinkActive'};
	$gLinkHover = $FORM{'LinkHover'};

	&putEnvVar;
	$gCurPage = $FORM{'p'};
	&readData;
}

sub lock {
	local($LockFile) = "$gBaseDIR/lock.txt";
	local($EndTime) = time+45;

	while(-e $LockFile && time < $EndTime) {}
	open(LOCK,">$LockFile");
	chmod 0666,$LockFile;

	if($gLockFlag eq 'Y') {
		flock(LOCK,2);
	}
	$gLockStat = 'Y';
}    

sub unlock {
	local($LockFile) = "$gBaseDIR/lock.txt";

	if($gLockStat eq 'Y') {
		if($gLockFlag eq 'Y') {
			flock(LOCK,8); 
		}
		close(LOCK);
		if(-e $LockFile) { 
			unlink($LockFile);
		}
		$gLockStat = 'N'; 
	}
}
